package ascensore.model;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class AscensoreBase extends Ascensore {
	
	public AscensoreBase(int pianoMin, int pianoMax, int pianoCorrente) {
		super(pianoMin, pianoMax, pianoCorrente);
    }
	
	@Override
	public boolean vaiAlPiano(int pianoArrivo){
		if (pianoArrivo>pianoMax || pianoArrivo<pianoMin) 
			throw new IllegalArgumentException("piano di arrivo fuori range");
		
		if (getStatoAscensore() != StatoAscensore.Fermo || 
				getPianoCorrente() != getPianoRichiesto() ||
				// Check necessario non suggerito nel testo
				getStatoAscensore() == StatoAscensore.Fermo && getPianoCorrente() == pianoArrivo) {
			return false;
		}
		
		setPianoRichiesto(pianoArrivo);
		return true;
	}

	@Override
	public String getTipo() {
		return "Base";
	}

	@Override
	public List<Integer> getPrenotazioni() {
		return getStatoAscensore() == StatoAscensore.Fermo && getPianoRichiesto() == getPianoCorrente()
				? new ArrayList<>(0)
				: Arrays.asList(getPianoRichiesto());
	}
	
	@Override
	public void arrivatoAlPianoGestisciPrenotazioni(){
		// Nell'ascensore base non fa assolutamente niente
	}

}
